package com.alterdekim.game.entity;

import com.alterdekim.flash.decompiler.mapper.FlashClass;
import com.alterdekim.flash.decompiler.mapper.FlashField;
import com.alterdekim.flash.decompiler.mapper.FlashValue;
import com.alterdekim.flash.decompiler.mapper.FlashValueType;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlProperty;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.Table;
import lombok.*;

@ToString
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name="mrids")
@FlashClass(name = "mr")
public class MediaResource {
    @Id
    @JacksonXmlProperty(isAttribute = true, localName = "Id")
    @FlashValue(type = FlashValueType.Id)
    private Long id;

    @JacksonXmlProperty(isAttribute = true, localName = "TId")
    @FlashField(name = "TId")
    @Column(nullable = false)
    private Integer tId;

    @JacksonXmlProperty(isAttribute = true, localName = "Url")
    @FlashField(name = "Url")
    @Column(nullable = false)
    private String url;

    @JacksonXmlProperty(isAttribute = true, localName = "V")
    @FlashField(name = "V")
    @Column(nullable = true)
    private String v;
}