package com.alterdekim.game.entity;

import com.alterdekim.flash.decompiler.mapper.FlashClass;
import com.alterdekim.flash.decompiler.mapper.FlashField;
import com.alterdekim.flash.decompiler.mapper.FlashValue;
import com.alterdekim.flash.decompiler.mapper.FlashValueType;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlProperty;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.Table;
import lombok.*;

@ToString
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name="trids")
@FlashClass(name = "tr")
public class TextResource {
    @Id
    @FlashValue(type = FlashValueType.Id)
    @JacksonXmlProperty(isAttribute = true, localName = "Id")
    private Long id;

    @FlashField(name = "OId")
    @Column(nullable = true)
    @JacksonXmlProperty(isAttribute = true, localName = "OId")
    private Integer oId;

    @FlashField(name = "H")
    @Column(nullable = false, length = 65555)
    @JacksonXmlProperty(isAttribute = true, localName = "H")
    private String h;
}
